题目
在 「力扣挑战赛」 开幕式的压轴节目 「无人机方阵」中,每一架无人机展示一种灯光颜色。 无人机方阵通过两种操作进行颜色图案变换:
- 调整无人机的位置布局
- 切换无人机展示的灯光颜色
给定两个大小均为 N*M
的二维数组 source
和 target
表示无人机方阵表演的两种颜色图案,由于无人机切换灯光颜色的耗能很大,请返回从 source
到 target
最少需要多少架无人机切换灯光颜色。
注意: 调整无人机的位置布局时无人机的位置可以随意变动。
示例 1:
输入:source = [[1,3],[5,4]], target = [[3,1],[6,5]]
输出:1
解释:
最佳方案为
将 [0,1] 处的无人机移动至 [0,0] 处;
将 [0,0] 处的无人机移动至 [0,1] 处;
将 [1,0] 处的无人机移动至 [1,1] 处;
将 [1,1] 处的无人机移动至 [1,0] 处,其灯光颜色切换为颜色编号为 6 的灯光;
因此从source 到 target 所需要的最少灯光切换次数为 1。
示例 2:
输入:source = [[1,2,3],[3,4,5]], target = [[1,3,5],[2,3,4]]
输出:0
解释:
仅需调整无人机的位置布局,便可完成图案切换。因此不需要无人机切换颜色
提示:
n == source.length == target.length
m == source[i].length == target[i].length
1 <= n, m <=100
1 <= source[i][j], target[i][j] <=10^4
解题
方法一:模拟 哈希表
思路
这题其实就是要求 source
中没有而 target
中有的元素的个数(元素可能重复),维护一个哈希表(counts
)记录颜色的计数,遍历 source
中元素在哈希表中加一,遍历 target
中元素在哈希表中减一。最后遍历一次哈希表,如果计数(count
)小于一就说明有 -count
个无人机需要换颜色,累加起来返回即可。
代码
class Solution {
static final int N = (int) 1e4 + 10;
public int minimumSwitchingTimes(int[][] source, int[][] target) {
int n = source.length, m = source[0].length;
int[] counts = new int[N];
for (int i = 0; i < n; ++i) {
for (int j = 0; j < m; ++j) {
++counts[source[i][j]];
--counts[target[i][j]];
}
}
int ans = 0;
for (int count : counts) {
if (count < 0) ans -= count;
}
return ans;
}
}
class Solution {
const int N = 1e4 + 10;
public:
int minimumSwitchingTimes(vector<vector<int>>& source, vector<vector<int>>& target) {
int n = source.size(), m = source[0].size();
int counts[N] = {0};
for (int i = 0; i < n; ++i) {
for (int j = 0; j < m; ++j) {
++counts[source[i][j]];
--counts[target[i][j]];
}
}
int ans = 0;
for (int count : counts) {
if (count < 0) ans -= count;
}
return ans;
}
};
评论区